-- Random Spawn for the Small Maze Lua Script

local function randomPositionSpawner()

	positions = { '-15.5 -133.3 0.42', '-168 -171.4 0.42', '171.5 -53.43 0.42', '137 57.4 0.42', '22.7 95.27 0.42', '-168 57.2 0.42', '-137 133.65 0.42', '-61 133.65 0.42' } -- Premade list of all spawnpoints possibles
	rotations = { '0 0 -1 90', '0 0 -1 90', '0 0 1 180', '0 0 -1 90', '0 0 -1 90', '0 0 -1 90', '0 0 1 90', '0 0 1 90' }
	randomValue = math.random(8) -- Create a random value in the range of the lists

	-- Modify the SpawnPoint
	TorqueScript.eval(
		[[
			scenario_player0.setTransform(matrixCreate("]] .. positions[randomValue] .. [[", "]] .. rotations[randomValue] .. [["));
			scenario_player0.requestReload();
		]])
	log('I', 'mazes.randomPositionSpawner', 'Vehicle moved to random position n° '..randomValue ..' ')
end

local function onScenarioChange(scenario)

	if scenario and scenario.state == 'pre-running' then
		log('I', 'mazes.onScenarioChange', 'Scenario started, starting set-up')
		randomPositionSpawner()
		log('I', 'mazes.onScenarioChange', 'Scenario set-up complete')
	end
end

return {
    onScenarioChange = onScenarioChange
}