-- Random Spawn for the Maths Maze Lua Script

local function randomPositionSpawner()

	positions = { '280 200 0.42', '280 80 0.42', '200 -160 0.42', '160 -200 0.42', '160 -80 0.42', '160 280 0.42', '120 -280 0.42', '120 80 0.42', '80 280 0.42', '80 120 0.42', '80 -120 0.42', '80 -240 0.42', '40 -40 0.42', '40 200 0.42', '0 0 0.42', '-40 -80 0.42', '-80 240 0.42', '-120 40 0.42', '-160 -40 0.42', '-200 -80 .42', '-280 40 0.42', '-280 -80 0.42'} -- Premade list of all spawnpoints possibles
	rotations = { '0 0 1 90', '0 0 1 90', '0 0 1 180', '0 0 -1 90', '0 0 -1 90', '1 0 0 0', '0 0 1 180', '0 0 1 180', '1 0 0 0', '0 0 -1 90', '0 0 -1 90', '0 0 1 180', '0 0 -1 90', '0 0 1 180', '1 0 0 0', '0 0 1 90', '0 0 1 180', '1 0 0 0', '0 0 -1 90', '0 0 -1 90', '0 0 -1 90', '0 0 -1 90'} -- Premade list of all rotations associated
	randomValue = math.random(22) -- Create a random value in the range of the lists

	-- Modify the SpawnPoint
	TorqueScript.eval(
		[[
			scenario_player0.setTransform(matrixCreate("]] .. positions[randomValue] .. [[", "]] .. rotations[randomValue] .. [["));
			scenario_player0.requestReload();
		]])
	log('I', 'mazes.randomPositionSpawner', 'Vehicle moved to random position n° '..randomValue ..' ')
end

local function onScenarioChange(scenario)
	if scenario and scenario.state == 'pre-running' then
		log('I', 'mazes.onScenarioChange', 'Scenario started, starting set-up')
		randomPositionSpawner()
		log('I', 'mazes.onScenarioChange', 'Scenario set-up complete')
	end
end

return {
    onScenarioChange = onScenarioChange
}