-- Random Spawn for the Maths Maze Lua Script

local function randomPositionSpawner()

	positions = { '0 21 0.42', '0 111 0.42', '0 169 0.42', '9 60 0.42', '31 170 0.42', '30 91 0.42', '31 110 0.42', '31 170 0.42', '41 10 0.42', '50 169 0.42', '50 139 0.42', '50 69 0.42', '50 41 0.42', '60 1 0.42', '59 180 0.42','81 20 0.42', '79 100 0.42', '89 150 0.42', '89 120 0.42', '90 79 0.42', '90 39 0.42', '90 1 0.42', '109 40 0.42', '111 70 0.42', '121 130 0.42', '129 100 0.42', '139 120 0.42', '150 141 0.42', '141 30 0.42', '160 149 0.42', '169 10 0', '170 59 0', '180 121 0', '180 89 0', '189 0 0', '189 50 0', '189 170 0'} -- Premade list of all spawnpoints possibles
	rotations = { '0 0 1 180', '0 0 1 180', '1 0 0 0', '0 0 1 90', '0 0 -1 90', '0 0 1 180', '0 0 -1 90', '0 0 -1 90', '0 0 -1 90', '1 0 0 0', '1 0 0 0', '1 0 0 0', '0 0 1 180', '0 0 1 180', '0 0 1 90', '0 0 -1 90', '0 0 1 90', '0 0 1 90', '0 0 1 90', '1 0 0 0', '1 0 0 0', '0 0 1 180', '0 0 1 90', '0 0 -1 90','0 0 -1 90', '0 0 1 90', '0 0 1 90', '0 0 -1 90', '1 0 0 0', '0 0 1 90', '1 0 0 0', '0 0 1 180', '0 0 1 180', '0 0 1 90', '0 0 1 90', '0 0 1 90'	}-- Premade list of all rotations associated
	randomValue = math.random(37) -- Create a random value in the range of the lists

	-- Modify the SpawnPoint
	TorqueScript.eval(
		[[
			scenario_player0.setTransform(matrixCreate("]] .. positions[randomValue] .. [[", "]] .. rotations[randomValue] .. [["));
			scenario_player0.requestReload();
		]])
	log('I', 'mazes.randomPositionSpawner', 'Vehicle moved to random position n° '..randomValue ..' ')
end

local function onScenarioChange(scenario)
	if scenario and scenario.state == 'pre-running' then
		log('I', 'mazes.onScenarioChange', 'Scenario started, starting set-up')
		randomPositionSpawner()
		log('I', 'mazes.onScenarioChange', 'Scenario set-up complete')
	end
end

return {
    onScenarioChange = onScenarioChange
}